# class REXML::Instruction

Represents an `XML` `Instruction`; IE, <? … ?> TODO: Add parent arg (3rd arg) to constructor

### Constants

START
STOP

### Attributes

content[RW]

target is the “name” of the `Instruction`; IE, the “tag” in <?tag …?> content is everything else.

target[RW]

target is the “name” of the `Instruction`; IE, the “tag” in <?tag …?> content is everything else.

### Public Class Methods

new(target, content=nil) click to toggle source

Constructs a new `Instruction` @param target can be one of a number of things. If `String`, then the target of this instruction is set to this. If an `Instruction`, then the `Instruction` is shallowly cloned (target and content are copied). @param content Must be either a `String`, or a `Parent`. Can only be a `Parent` if the target argument is a `Source`. Otherwise, this `String` is set as the content of this instruction.

Calls superclass method `REXML::Child::new`

    # File lib/rexml/instruction.rb, line 25
    def initialize(target, content=nil)
      case target
      when String
        super()
        @target = target
        @content = content
      when Instruction
        super(content)
        @target = target.target
        @content = target.content
      else
        message =
          "processing instruction target must be String or REXML::Instruction: "
        message << "<#{target.inspect}>"
        raise ArgumentError, message
      end
      @content.strip! if @content
    end

### Public Instance Methods

==( other ) click to toggle source

@return true if other is an `Instruction`, and the content and target of the other matches the target and content of this object.

    # File lib/rexml/instruction.rb, line 65
    def ==( other )
      other.kind_of? Instruction and
      other.target == @target and
      other.content == @content
    end

clone() click to toggle source

    # File lib/rexml/instruction.rb, line 44
    def clone
      Instruction.new self
    end

inspect() click to toggle source

    # File lib/rexml/instruction.rb, line 75
    def inspect
      "<?p-i #{target} ...?>"
    end

node_type() click to toggle source

    # File lib/rexml/instruction.rb, line 71
    def node_type
      :processing_instruction
    end

write(writer, indent=-1, transitive=false, ie_hack=false) click to toggle source

## DEPRECATED¶ ↑

See the rexml/formatters package

    # File lib/rexml/instruction.rb, line 51
    def write writer, indent=-1, transitive=false, ie_hack=false
      Kernel.warn( "#{self.class.name}.write is deprecated", uplevel: 1)
      indent(writer, indent)
      writer << START
      writer << @target
      if @content
        writer << ' '
        writer << @content
      end
      writer << STOP
    end